<?php

namespace ShineSoftware\Constriv\Controller\Hosted;

use Magento\Framework\App\Action\Context;
use Magento\Quote\Model\QuoteFactory;
use Magento\Sales\Model\OrderFactory;
use ShineSoftware\Constriv\Model\Logger\Shinelogger;

class Error extends AbstractHosted {

    /**
     * @var OrderFactory
     */
    protected $_modelOrderFactory;
    
    /**
     *
     * @var \Magento\Checkout\Model\Session 
     */
    protected $session;


    public function __construct(
            Context $context, 
            QuoteFactory $modelQuoteFactory, 
            Shinelogger $logLoggerInterface, 
            OrderFactory $modelOrderFactory,
            \Magento\Checkout\Model\Session $session) {
        $this->_modelOrderFactory = $modelOrderFactory;
        $this->session = $session;

        parent::__construct($context, $modelQuoteFactory, $logLoggerInterface);
    }

    public function execute() {
        $order = $this->session->getLastRealOrder();
        if ($order->getId() && $order->getState() != \Magento\Sales\Model\Order::STATE_CANCELED) {
            $message = "There was a problem in the payment process, please try again!";
            $order->registerCancellation()->save();
            if ($this->session->restoreQuote()) {
                $this->_logger->debug(__METHOD__ . " - Quote has been restored! The user will be redirected to the cart!");
            } else {
                $this->_logger->debug(__METHOD__ . " - Quote has been NOT restored! The user will be redirected to the failure page!");
            }
            $this->messageManager->addErrorMessage($message);
        }
        $this->_redirect($this->_url->getUrl('checkout/cart/index'));
    }

}
